define([
    'jquery',
    'underscore',
    'backbone',
    'handlebars',
    'etchjs',
    'collections/projects',
    'models/task',
    'assets/templates/project',
    'assets/templates/_task',
    'assets/templates/_new'
    ], function($, _, Backbone, Handlebars, Etchjs, ProjectsCollection, TaskModel, ProjectTemplate, TaskTemplate, NewTemplate) {
    var TaskDetailView = Backbone.View.extend({
        initialize: function() {
            _.bindAll(this, 'save');
            this.model.bind('save', this.save);
            _.extend(etch.config.buttonClasses, {
               'default': [
                   'bold fa fa-bold',
                   'italic fa fa-italic',
                   'underline fa fa-underline',
                   'save fa fa-save'
               ],
               'caption': ['bold', 'italic', 'underline', 'link', 'save']
             });
        },

        events: {
            "mousedown .editable": etch.editableInit,
            // "mousedown .editable": "initEditable",
            "click .fa-square-o": "showRelated",
            "click .fa-check-square-o": "showAll",
            "click .fa-pencil-square-o": "editTask",
            "click .fa-sticky-note-o": "newTask",
            "click .fa-comment-o": "newTask",
        },

        showRelated: function(e) {
            e.preventDefault();
            var $content = $(this.el).find('.content');
            var $square = $(this.el).find('.fa-square-o');
            $square.removeClass("fa-square-o");
            $square.addClass("fa-check-square-o");
            $content.addClass("active");
            $(".col-2 .content").not(".active").not(".new").hide();
            $(".col-3 .content").not(".active").not(".new").hide();
            if ($(this.el).parent().hasClass('col-2')) {
                $(".col-3 .content").not(".new").removeClass("active").hide()
                    .find(".fa-check-square-o").removeClass("fa-check-square-o").addClass("fa-square-o");
                $(".col-3 .content.comment-"+$content.data("id")).show();
            } else {
                $(".col-2 .content").not(".new").removeClass("active").hide()
                    .find(".fa-check-square-o").removeClass("fa-check-square-o").addClass("fa-square-o");
                $(".col-2 .content.change-"+$content.data("id")).show();
            }
        },

        showAll: function(e) {
            e.preventDefault();
            var $content = $(this.el).find('.content');
            var $square = $(this.el).find('.fa-check-square-o');
            $square.removeClass("fa-check-square-o");
            $square.addClass("fa-square-o");
            $content.removeClass("active");
            $(".col-2 .content").show();
            $(".col-3 .content").show();
        },

        clicked: function(e){
            etch.editableInit
            e.preventDefault();
            console.log(this.model);
            // var name = this.model.get("name");
            // alert(name);
        },

        editTask: function(){
            // $('.editable', this.$el).trigger("click");
        },

        render: function(){
            // var template = $("#item-template");
            // var html = template.tmpl(this.model.toJSON());
            // $(this.el).append(html);
            // var partial = Handlebars.partials['_task'](this.model.attributes);
            // $(this.el).append(partial);
            this.$el.html(Handlebars.partials['_task'](this.model.attributes));
            return this;
        },

        initEditable: function(e) {
            console.log("onit");
            etch.editableInit(e);
        },

        save: function() {
            var text = $(this.el).find('.editable').html(),
                that = this,
                tokenString = localStorage.getItem("comm_token"),
                uid = localStorage.getItem("comm_uid");

            if (this.model.get("text") !== text) {
                this.model.save({text: text},
                    {
                        headers: { 'Authorization' : uid+':'+tokenString },
                        success: function (model, response) {
                            that.render();
                        },
                        error: function (model, response) {
                            console.log("error");
                        }
                    });
            }
        },

        newTask: function() {
            this.model.trigger("createTask", this.model);
        }
    });

    return TaskDetailView;
});
