// Filename: views/users/register
define([
    'jquery',
    'underscore',
    'backbone',
    'handlebars',
    'assets/templates/_register',
    'models/user'
], function($, _, Backbone, Handlebars, RegisterTemplate, UserModel) {
    var RegisterView = Backbone.View.extend({
        el: $("#container"),

        initialize: function() {
        },

        events: {
            "click #registerButton": "register",
            'change input#username': 'changeUsername',
            'change input#password': 'changePassword'
        },

        changeUsername: function(e) {
            var val = $(e.currentTarget).val();
            this.model.set({'username': val});
        },

        changePassword: function(e) {
            var val = $(e.currentTarget).val();
            this.model.set({'password': val});
        },

        render:function () {
            var data = {
                username : this.model.get('username'),
                message : this.model.get('message')
            };

            this.$el.html(Handlebars.partials['_register'](data));
            return this;
        },

        register: function(event) {
            event.preventDefault();
            var that = this,
                obj = {
                    username: this.model.get('username'),
                    password: this.model.get('password')
                };

            this.model.save(obj, {
                success: function (model, response) {
                    that.render();
                },
                error: function (model, response) {
                    console.log("error");
                }
            });
        }
    });

    return RegisterView;
});
