<?php

class Response {
    public function headerResponse($status_code, $response) {
        $app = \Slim\Slim::getInstance();
        // Http response code
        $app->status($status_code);
        // setting response content type to json
        $app->contentType('application/json');
        echo json_encode($response);
    }

    function middle($request, $response, $next) {
        $response->getBody()->write('BEFORE');
        $response = $next($request, $response);
        $response->getBody()->write('AFTER');

        return $response;
    }

    /**
     * Adding Middle Layer to authenticate every request
     * Checking if the request has valid api key in the 'Authorization' header
     */
    public function authenticate($request, $response, $next) {
        $headers = apache_request_headers();
        // $response = array();

        if (isset($headers['Authorization'])) {
            $api_key = $headers['Authorization'];

            list($uid, $token) = explode(':', $api_key);
            if (is_null($uid) || $uid == "" || is_null($token) || $token == "") {
                $r = $response->withStatus(401, 'Unauthorized');
                $r->getBody()->write('Unauthorized');
                return $r;
            }

            $data = new User();
            $user = $data->getUserById($uid);
            if (is_null($user)) {
                $r = $response->withStatus(401, 'Unauthorized');
                $r->getBody()->write('Unauthorized');
                return $r;
            }

            if ($user->token != $token) {
                $r = $response->withStatus(401, 'Unauthorized');
                $r->getBody()->write('Unauthorized');
                return $r;
            }
        } else {
            $r = $response->withStatus(401, 'Unauthorized');
            $r->getBody()->write('Unauthorized');
            return $r;
        }

        $response = $next($request, $response);
        return $response;
    }
}
