<?php

use RedBeanPHP\R;

class Article {

    protected $table;

    function __construct() {
        $settings = require __DIR__ . '/../settings.php';
        $this->table = $settings['settings']['db']['prefix'].'article';
    }

    public function getArticles($project = 0, $page = 0) {
        $result = array();
        $filter = "";

        if ($project != 0) $filter = " project_id = ".$project;

        $articles = R::findAll( $this->table , $filter." LIMIT $page, 10 " );

        foreach ($articles as $article)
            $result[] = array("id" => $article->id, "project" => $article->project_id, "text" => $article->text);

        return $result;
    }

    public function getArticle($id) {
        $article = R::load( $this->table , $id );

        $result = array("id" => $article->id, "project" => $article->project_id, "text" => $article->text);

        $task = new Task();
        $result["comments"] = $task->getTasks($id, 0);
        $result["changes"] = $task->getTasks($id, 1);

        return $result;
    }
}
